/*
 * maX.500 view templates Rez/DeRez definitions
 *
 * 5 March 1992 Mark C Smith
 * modified 9 March 1993 by MCS
 *
 */

#define ITEM_STATICTEXT		1
#define ITEM_EDITTEXT		2
#define ITEM_IMAGE			4
#define ITEM_BUTTON			8
#define ITEM_CHECKBOX		16

#define NoRed				0x0000
#define NoGreen				0x0000
#define NoBlue				0x0000
#define FullRed				0xffff
#define FullGreen			0xffff
#define FullBlue			0xffff

type 'fnts' {
	integer = $$CountOf(fntarray); 							/* count of fonts */
	wide array fntarray {									/* font names */
		wstring;
	};
};


type 'octp' {
	longint;												/* version */
	wstring;												/* template name */
	integer = $$CountOf(ocarray); 							/* count of ocs */
	integer = $$CountOf(defaarray);							/* count of attrs. that are defaulted for new */
	wide array ocarray {									/* associated object classes */
		wstring;
	};
	wide array defaarray {
		wstring;											/* the attribute to default */
		wstring;											/* first character indicates how to */
															/* default: [c]onstant, [d]n, or    */
															/* [a]ttribute of adder's entry.    */
															/* The rest is /value, nothing, /attribute */
	};
	wstring;												/* DN attribute to auth. as */
	wstring;												/* default DN location (parent) when adding */
	wstring;												/* default RDN attribute type when adding */
	integer;												/* template horizontal size (pixels) */
	integer;												/* template vertical size (pixels) */
	fill bit[4];
	boolean addable=1, notaddable=0;						/* user can try to add these or not */
	boolean autosize=1, fixedsize=0;						/* auto resize or fixed size? */
	boolean oneitem=1, multitem=0;							/* one item fills entire window? */
	boolean modal=1, modeless=0;							/* modal or modeless window? */
	fill byte;						/* short align */
	integer = $$CountOf(octiarray); 						/* count of items */
	wide array octiarray {
		wstring;											/* associated attribute */
		rect;												/* item bounds: 8 bytes */
		fill bit[30];
		boolean readonly=1, readwrite=0;					/* item flags */
		boolean boxed=1, noboxed=0;
		switch {
		case StaticText:									/* fixed text item */
			key bitstring[8] = ITEM_STATICTEXT;				/* item type */
			fill bit[8];					/* short align */
			fill bit[5];
			boolean underline=1, nounderline=0;				/* style */
			boolean italic=1, noitalic=0;
			boolean bold=1, nobold=0;
			fill bit[8];					/* short align */
			integer;										/* size */
			integer;										/* color red component */
			integer;										/* color green component */
			integer;										/* color blue component */
			integer;										/* font number */
			wstring;										/* text */
			
		case EditText:
			key bitstring[8] = ITEM_EDITTEXT;				/* editable text item */
			fill bit[8];					/* short align */
			fill bit[5];
			boolean underline=1, nounderline=0;				/* style */
			boolean italic=1, noitalic=0;
			boolean bold=1, nobold=0;
			fill bit[8];					/* short align */
			integer;										/* size */
			integer;										/* color red component */
			integer;										/* color green component */
			integer;										/* color blue component */
			integer;										/* font number */
			fill bit[32];			/* to make same size as static text */
			
		case Image:
			key bitstring[8] = ITEM_IMAGE;				/* Fax or JPEG image */
			fill bit[136];			/* to make same size as static text */
			
		case Button:
			key bitstring[8] = ITEM_BUTTON;				/* button control item */
			fill bit[8];					/* short align */
			boolean changelabel=1, nochangelabel=0;		/* change label after pushing? */
			boolean exec=1, noexec=0;					/* call execute routine for value */
			boolean hide=1, deactivate=0;				/* if no values... */
			boolean nextval=1, nonextval=0;				/* template link steps through values */
			boolean close=1, noclose=0;					/* close window when button pressed? */
			boolean bool=1, nobool=0;					/* boolean button or not */
			boolean default=1, nodefault=0;				/* default to a value or not */
			boolean defaulttrue=1, defaultfalse=0;		/* default value */
			boolean adddnvals=1, noadddnvals=0;			/* button is link to Add DN vals dialog */
			boolean copyvals=1, nocopyvals=0;			/* button copies values to auth. entry */
			fill bit[22];					/* to make same size as static text */
			wstring;									/* button text */
			wstring;									/* false button text (if bool=1) 
														 or change label text (if changelabel=1)
														 or title bar text (if adddnvals=1)
														 or confirm prompt (if copyvals=1) */
			wstring;									/* name of template to link to
														 or search object bitmap (if adddnvals=1)
														 or dest attr. specifier (if copyvals=1) */

		case CheckBox:
			key bitstring[8] = ITEM_CHECKBOX;			/* checkbox control item */
			fill bit[8];					/* short align */
			fill bit[5];
			boolean hide=1, deactivate=0;				/* if no values... */
			boolean default=1, nodefault=0;				/* default to a value or not */
			boolean defaulttrue=1, defaultfalse=0;		/* default value */
			fill bit[40];					/* to make same size as static text */
			integer;									/* color red component */
			integer;									/* color green component */
			integer;									/* color blue component */
			wstring;									/* checkbox text */
		};
	};
};
 